#include <iostream>
#include <cmath>

using namespace std;

double f(double x){
	return x*x*x + x*x - 2*x - 2;
}

double fp(double x){
	return 3*x*x + 2*x - 2;
}

double tolerans = 0.0000000001;

void findBisection(double x1, double x2){
	double hata = 1.0;
	
	double x = 1;
	
	int say = 0;
	
	while(x2-x1 > tolerans){
		x = (x1 + x2) / 2;
		printf("%d\tx = %.15f\tf(x) = %.15f\n", say++, x, f(x));
		if( f(x) * f(x1) < 0 )
			x2 = x;
		else
			x1 = x;
	}
}

void findNewton(double x){
	double x_eski = x + 1;
	int say = 0;
	
	while(abs(x_eski - x) > tolerans){
		x_eski = x;
		x = x_eski - f(x_eski) / fp(x_eski);
		printf("%d\tx = %.15f\tf(x) = %.15f\n", say++, x, f(x));
	}
}

void findSecant(double x){
	double x_eski = x + 1;
	double x_eeski = x + 5;
	int say = 0;
	
	while(abs(x_eski - x) > tolerans){
		x_eeski = x_eski;
		x_eski = x;
		x = x_eski - f(x_eski) * (x_eski - x_eeski) / (f(x_eski) - f(x_eeski));
		printf("%d\tx = %.15f\tf(x) = %.15f\n", say++, x, f(x));
	}
}

int main ( void )
{
	cout << endl << "------------- BISECTION -----------------------------------------" << endl << endl; 
	findBisection(-5.0, 5.0);
	cout << endl << "-------------- NEWTON -------------------------------------------" << endl ; 
	findNewton(10.0);
	cout << endl << "-------------- SECANT -------------------------------------------" << endl ; 
	findSecant(10.0);
	
    system ( "PAUSE" );
    return 1;
}
